<?php

/*********************************************************************

 アルバム漫画表示プラグイン (2013/04/14)

 Copyright(C) 2009-2013 freo.jp

*********************************************************************/

//外部ファイル読み込み
require_once FREO_MAIN_DIR . 'freo/plugins/security_plugin_album.php';
require_once FREO_MAIN_DIR . 'freo/plugins/filter_plugin_album.php';

/* メイン処理 */
function freo_page_album_comic()
{
	global $freo;

	switch ($_REQUEST['freo']['work']) {
		default:
			freo_page_album_comic_default();
	}

	return;
}

/* 漫画表示 */
function freo_page_album_comic_default()
{
	global $freo;

	//パラメータ検証
	if (!isset($_GET['id']) and isset($freo->parameters[1])) {
		$parameters = array();
		$i          = 0;
		while (isset($freo->parameters[++$i])) {
			if (!$freo->parameters[$i]) {
				continue;
			}
			$parameters[] = $freo->parameters[$i];
		}
		$_GET['id'] = implode('/', $parameters);
	}
	if (!isset($_GET['id']) or !preg_match('/^[\w\-\/]+$/', $_GET['id'])) {
		freo_error('表示したいアルバムIDを指定してください。');
	}

	if (isset($_GET['navigation']) and $_GET['navigation'] == 'off') {
		$_GET['navigation'] = 'off';
	} else {
		$_GET['navigation'] = 'on';
	}

	if (isset($_GET['columns']) and $_GET['columns'] == 1) {
		$_GET['columns'] = 1;
	} else {
		$_GET['columns'] = 2;
	}

	if (isset($_GET['devide']) and $_GET['devide'] == 'on') {
		$_GET['devide'] = 'on';
	} else {
		$_GET['devide'] = 'off';
	}

	if (isset($_GET['direction']) and $_GET['direction'] == 'ltr') {
		$_GET['direction'] = 'ltr';
	} else {
		$_GET['direction'] = 'rtl';
	}

	if (isset($_GET['end']) and $_GET['end'] == 'on') {
		$_GET['end'] = 'on';
	} else {
		$_GET['end'] = 'off';
	}

	if (isset($_GET['page'])) {
		$_GET['page'] = intval($_GET['page']);
	} else {
		$_GET['page'] = 0;
	}

	//リクエストメソッドに応じた処理を実行
	if ($_SERVER['REQUEST_METHOD'] == 'POST') {
		if (isset($_POST['plugin_album_comic'])) {
			//パスワード認証
			$stmt = $freo->pdo->prepare('SELECT * FROM ' . FREO_DATABASE_PREFIX . 'plugin_albums WHERE id = :id AND restriction = \'password\' AND password = :password');
			$stmt->bindValue(':id',       $_GET['id'], PDO::PARAM_INT);
			$stmt->bindValue(':password', $_POST['plugin_album_comic']['password']);
			$flag = $stmt->execute();
			if (!$flag) {
				freo_error($stmt->errorInfo());
			}

			if ($data = $stmt->fetch(PDO::FETCH_ASSOC)) {
				$_SESSION['security']['plugin_album'][$_GET['id']] = true;
				freo_redirect('album_comic/' . $_GET['id'] . '?' . $_POST['plugin_album_comic']['parm']);
			} else {
				$freo->smarty->append('errors', 'パスワードが違います。');
			}
		} else {
			//ワンタイムトークン確認
			if (!freo_token('check')) {
				$freo->smarty->append('errors', '不正なアクセスです。');
			}
		}
	}

	//アルバム取得
	$stmt = $freo->pdo->prepare('SELECT * FROM ' . FREO_DATABASE_PREFIX . 'plugin_albums WHERE id = :id');
	$stmt->bindValue(':id', $_GET['id']);
	$flag = $stmt->execute();
	if (!$flag) {
		freo_error($stmt->errorInfo());
	}

	if ($data = $stmt->fetch(PDO::FETCH_ASSOC)) {
		$plugin_album = $data;
	} else {
		freo_error('指定されたアルバムが見つかりません。');
	}

	//アルバムフィルター取得
	$plugin_album_filters = freo_filter_plugin_album('user', array($_GET['id']));
	$plugin_album_filter  = $plugin_album_filters[$_GET['id']];

	if ($plugin_album_filter) {
		$plugin_album['title']     = str_replace('[$title]', $plugin_album['title'], $freo->config['plugin']['album']['filter_title']);
		$plugin_album['file']      = null;
		$plugin_album_files        = null;
		$plugin_album['text']      = str_replace('[$text]', $plugin_album['text'], $freo->config['plugin']['album']['filter_text']);
	}

	//アルバム保護データ取得
	$plugin_album_securities = freo_security_plugin_album('user', array($_GET['id']));
	$plugin_album_security   = $plugin_album_securities[$_GET['id']];

	if ($plugin_album_security) {
		$plugin_album['title']     = str_replace('[$title]', $plugin_album['title'], $freo->config['plugin']['album']['restriction_title']);
		$plugin_album['file']      = null;
		$plugin_album_files        = null;
		$plugin_album['text']      = str_replace('[$text]', $plugin_album['text'], $freo->config['plugin']['album']['restriction_text']);
	}

	//閲覧制限の有無を確認
	$restrict_flag = false;
	if ($plugin_album_filter or $plugin_album_security) {
		$restrict_flag = true;
	}

	//表紙の有無を検証
	$cover = null;

	if ($dir = scandir(FREO_FILE_DIR . 'plugins/album_files/' . $_GET['id'], 1)) {
		foreach ($dir as $entry) {
			if (preg_match('/^1\.(gif|jpeg|jpg|jpe|png)$/i', $entry)) {
				$cover = false;
			} elseif (preg_match('/^0\.(gif|jpeg|jpg|jpe|png)$/i', $entry)) {
				$cover = true;
			}
		}
	} else {
		freo_error('画像格納ディレクトリを開けません。');
	}

	if ($cover === null) {
		freo_error('漫画が見つかりません。', '404 Not Found');
	}

	//画像を取得
	$album_comics = array();
	$i            = 0;
	$count        = 0;

	if ($cover) {
		$flag = false;
	} else {
		$flag = true;
	}

	if ($dir = scandir(FREO_FILE_DIR . 'plugins/album_files/' . $_GET['id'])) {
		natcasesort($dir);

		foreach ($dir as $entry) {
			if (is_file(FREO_FILE_DIR . 'plugins/album_files/' . $_GET['id'] . '/' . $entry) and preg_match('/^[\d]+\.(gif|jpeg|jpg|jpe|png)$/i', $entry)) {
				$id = intval($entry);

				if ($_GET['columns'] == 2) {
					if ($id % 2 == 0) {
						$link = $i + 1;
					} else {
						$link = $i - 1;
					}
				} else {
					$link = $i + 1;
				}

				$album_comics[$i][] = array(
					'id'   => $id,
					'file' => $entry,
					'link' => $link
				);

				if ($_GET['columns'] == 2) {
					if ($flag) {
						$flag = false;
					} else {
						$flag = true;
					}

					if ($flag) {
						$i++;
					}
				} else {
					$i++;
				}

				$count++;
			}
		}
	} else {
		freo_error('画像格納ディレクトリを開けません。');
	}

	//先頭ページリンク先を調整
	if ($cover === false and $_GET['columns'] == 2) {
		$album_comics[0][0]['link'] = 0;
	}

	//末尾ページリンク先を調整
	if ($_GET['end'] == 'on') {
		if ($_GET['devide'] == 'on') {
			if ($_GET['columns'] == 2) {
				$end_link = floor($count / 2);

				if ($count % 2 + $cover) {
					$end_link += 1;
				}
			} else {
				$end_link = $count;
			}
		} else {
			if ($_GET['columns'] == 2) {
				$end_link = floor($count / 2);

				if ($count % 2 + $cover) {
					$end_link += 1;
				}
			} else {
				$end_link = $count;
			}
		}
	} else {
		if ($_GET['devide'] == 'on') {
			if ($_GET['columns'] == 2) {
				$end_link = 0;
			} else {
				$end_link = 0;
			}
		} else {
			if ($_GET['columns'] == 2) {
				$end_link = 0;
			} else {
				$end_link = 0;
			}
		}
	}
	$album_comics[count($album_comics) - 1][count($album_comics[count($album_comics) - 1]) - 1]['link'] = $end_link;

	//画像をソート
	if (ksort($album_comics, SORT_NUMERIC) == false) {
		freo_error('画像をソートできません。');
	}

	//ファイル情報を取得
	list($file_width, $file_height) = freo_file(FREO_FILE_DIR . 'plugins/album_files/' . $_GET['id'] . '/' . $album_comics[0][0]['file']);

	$first    = 0;
	$last     = $count - 1;
	$all      = $id;
	$from     = $first;
	$to       = $last;
	$end      = $to + 1;
	$previous = $first;
	$next     = $first + 1;

	if ($_GET['end'] == 'on') {
		if ($_GET['columns'] == 2) {
			if ($last % 2) {
				$to = floor($last / 2) + 1;

				if ($cover) {
					$to += 1;
				}
			} else {
				$to = floor($last / 2) + 1;
			}

			$last = floor($last / 2) + 1;
			$end  = $to;

			if ($_GET['page'] > 0) {
				$previous = $_GET['page'] - 1;
			} else {
				$previous = 0;
			}

			if ($_GET['page'] < $to) {
				$next = $_GET['page'] + 1;
			} else {
				$next = $to;
			}
		} else {
			if ($last % 2) {
				$to = $last + 1;

				if ($cover) {
				}
			} else {
				$to = $last + 1;
			}

			if ($_GET['page'] > 0) {
				$previous = $_GET['page'] - 1;
			} else {
				$previous = 0;
			}

			if ($_GET['page'] < $to) {
				$next = $_GET['page'] + 1;
			} else {
				$next = $to;
			}
		}
	} else {
		if ($_GET['columns'] == 2) {
			if ($last % 2) {
				$to = floor($last / 2);

				if ($cover) {
					$to += 1;
				}
			} else {
				$to = floor($last / 2);
			}

			$last = floor($last / 2) + 1;
			$end  = $to;

			if ($_GET['page'] > 0) {
				$previous = $_GET['page'] - 1;
			} else {
				$previous = 0;
			}

			if ($_GET['page'] < $to) {
				$next = $_GET['page'] + 1;
			} else {
				$next = $to;
			}
		} else {
			if ($last % 2) {
				if ($cover) {
				}
			} else {
			}

			if ($_GET['page'] > 0) {
				$previous = $_GET['page'] - 1;
			} else {
				$previous = 0;
			}

			if ($_GET['page'] < $last) {
				$next = $_GET['page'] + 1;
			} else {
				$next = $last;
			}
		}
	}

	//ページ情報を取得
	$album_comic_pages = array();
	$show              = null;

	for ($i = $first; $i <= $last; $i++) {
		if ($cover and $i <= $from) {
			continue;
		}

		if ($_GET['columns'] == 2) {
			if ($i >= $last) {
				break;;
			}

			if ($cover) {
				$page = $i - 1;
			} else {
				$page = $i;
			}

			if ($page == $last - 1 and $last % 2 == 0) {
				$label = ($page * 2 + 1);
			} else {
				$label = ($page * 2 + 1) . '-' . ($page * 2 + 2);
			}
		} else {
			if ($cover) {
				$page = $i - 1;
			} else {
				$page = $i;
			}

			$label = $page + 1;
		}

		if ($i == $_GET['page']) {
			$show = $label;
		}

		$album_comic_pages[] = array(
			'id'    => $i,
			'label' => $label
		);
	}

	//データ割当
	$freo->smarty->assign(array(
		'token'                          => freo_token('create'),
		'plugin_album'                   => $plugin_album,
		'plugin_album_comics'            => $album_comics,
		'plugin_album_comic_id'          => $_GET['id'],
		'plugin_album_comic_pages'       => $album_comic_pages,
		'plugin_album_comic_dir'         => FREO_FILE_DIR . 'plugins/album_files/' . $_GET['id'] . '/',
		'plugin_album_comic_cover'       => $cover,
		'plugin_album_comic_first'       => $first,
		'plugin_album_comic_last'        => $last,
		'plugin_album_comic_all'         => $all,
		'plugin_album_comic_from'        => $from,
		'plugin_album_comic_to'          => $to,
		'plugin_album_comic_end'         => $end,
		'plugin_album_comic_previous'    => $previous,
		'plugin_album_comic_next'        => $next,
		'plugin_album_comic_show'        => $show,
		'plugin_album_comic_width'       => $file_width,
		'plugin_album_comic_height'      => $file_height,
		'plugin_album_comic_restriction' => $restrict_flag
	));

	return;
}

?>
